#include <iostream>
using namespace std;

class who {
	char w;
public:
	who(){ w = '?';cout << w << "のコンストラクタ\n";}
	who(char c){ w = c;cout << w << "のコンストラクタ\n";}
	~who() {cout << w << "のデストラクタ\n";}
};

who makewho();

who makewho(char c)
{
	cout << "makewho(" << c << ")\n";
	who w(c);
	return w;
}

int main()
{
	cout << "main";
	who x('x');
	x = makewho('a');
	x = makewho('b');
	
	return 0;
}